<template>
    <div class="form-comment">
        <form class="form" @submit.prevent="handleSubmit">
            <button data-test="btn-toggle" @click="resetForm" type="button" v-if="isEditing" class="button new-comment" >New comment</button>
            <div class="form-group">
                <label for="name">Name</label>
                <input data-test="input-name" v-model="commentForm.name" type="text" name="name" class="input-control" placeholder="Name of the comment">
            </div>
            <div class="form-group">
                <label for="email">Email</label>
                <input data-test="input-email" v-model="commentForm.email" type="text" name="email" class="input-control" placeholder="Your email">
            </div>
            <div class="form-group">
                <label for="body">Body</label>
                <textarea data-test="input-body" v-model="commentForm.body" type="text" name="body" class="textarea-control" placeholder="Type here the body of the comment" rows="6" />
            </div>
            <div class="form-group">
                <button data-test="btn-submit" type="submit" class="button">{{ isEditing ? 'Edit comment' : 'Create comment' }}</button>
            </div>
        </form>
    </div>
</template>

<script>
export default {
    name: 'FormComment',
    data() {
        return {
            commentForm: {},
            isEditing: false
        }
    },
    methods: {
        resetForm() {
            this.isEditing = false
            this.commentForm = {}
        },
        updateForm(comment) {
            this.commentForm = Object.assign({}, comment)
            this.isEditing = true
        },
        handleSubmit() {
            if(!this.commentForm.name || !this.commentForm.email || !this.commentForm.body) {
                return
            }

            if(this.isEditing) {
                this.$emit('edit-comment', this.commentForm)
            } else {
                this.$emit('add-comment', this.commentForm)
            }

            this.resetForm()
        }
    }
}
</script>

<style scoped>
    .form {
        background: rgba(27, 27, 50, 0.8);
        border-radius: .3rem;
        padding: 2rem;
        color: white;
        margin: auto;
        margin-bottom: 1rem;
        width: 90%;
    }

    .form-group {
        max-width: 100%;
        display: flex;
        flex-direction: column;
        margin: 2rem 0;
    }

    .input-control {
        display: block;
        height: 2rem;
        border-radius: .3rem;
        padding: .3rem;
        border: 1px solid #dddddd;
        margin-top: .3rem;
        font-size: 1.1rem;
    }
    
    .textarea-control {
        resize: vertical;
        min-height: 50px;
        font-size: 1.2rem;
        padding: .3rem;
    }

    .button {
        padding: .6rem;
        background: #55d185;
        border: none;
        cursor: pointer;
        color: white;
        border-radius: .2rem;
    }

    .button:hover {
        background: #6ce099;
    }

    .new-comment {
        margin-left: auto;
        display: block;
    }

    @media screen and (min-width: 1024px) {
        .form {
            width: 60%;
        }
    }

</style>